import 'package:flutter_mylibrary/base/provider/request_info.dart';
import 'package:flutter_mylibrary/http/dio_utils.dart';
import 'package:flutter_mylibrary/utils/utils.dart';

import '../view_state_model.dart';

abstract class ViewStateRequestModel<T> extends ViewStateModel{

  T data;

  RequestInfo getRequestInfo();

  void initData() async{
    RequestInfo requestInfo = getRequestInfo();
    data = await DioUtils.getInstance().request(
      requestInfo?.method,
      requestInfo?.url,
      data: requestInfo?.data,
      viewStateModel: this,
      publicMethod: false
    ).then((res) => T is List? getObjList(res.data, (v) => requestInfo?.handleRes(v)) : getObject<T>(res.data, (v) => requestInfo?.handleRes(v)));
  }
}

